import org.math.plot.*;
import javax.swing.JFrame;
import java.io.*;


public class HistPlotter
{
	private String filename;
	private Plot2DPanel plot;
	private JFrame frame;
	
	public HistPlotter(String fn,int nBins)
	{
		filename = fn;
		frame = new JFrame();
		plot = new Plot2DPanel();
		try
		{
		
			int nL = countLines(filename); // Number of lines in file less header
			nL-=1;
			System.out.println(nL);
			
			BufferedReader in = new BufferedReader(new FileReader(filename)); 
			
			// Read the headers
			String text = in.readLine(); 
			String[] splitString = text.split("\t");
			String xlabel = splitString[0];
			String ylabel = splitString[1];
			int nVar = splitString.length - 1;
			String[] legends = new String[nVar];
			for(int i=0;i<nVar;i++)
			{
				legends[i] = splitString[i+1];	
			}
			
			double[] xdata = new double[nL];
			double[][] ydata = new double[nL][nVar];
			
			for(int i=0;i<nL;i++)
			{
				text = in.readLine();
				splitString = text.split("\t");
				xdata[i] = Double.parseDouble(splitString[0]);
				for(int j=0;j<nVar;j++)
				{
					ydata[i][j] = Double.parseDouble(splitString[j+1]);	
				}
			}			
			
			in.close();
			for(int i=0;i<nVar;i++)
			{
				double[] tempy = new double[nL];
				for(int j=0;j<nL;j++)
				{
					tempy[j] = ydata[j][i];	
				}
				
				try
				{
					plot.addHistogramPlot(legends[i],tempy,nBins);
				}
				catch(NullPointerException e)
				{
					System.out.println("Couldn't plot histogram for " + legends[i]);	
				}
			}
			
			plot.setAxisLabel(0,"Time");
			plot.setAxisLabel(1,"Population");	
			plot.addLegend("SOUTH");
					
			frame.setContentPane(plot);
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			frame.setSize(500,500);
			frame.setVisible(true);
	
	
		}
		catch(FileNotFoundException e)
		{
			System.out.println("Couldn't load file");
			System.exit(0);	
		}
		catch(IOException e)
		{
			System.out.println("Couldn't load file");
			System.exit(0);				
		}
	}
	


	public int countLines(String filename) throws IOException
	{
    	LineNumberReader reader  = new LineNumberReader(new FileReader(filename));
		int cnt = 0;
		String lineRead = "";
		while ((lineRead = reader.readLine()) != null) {}

		cnt = reader.getLineNumber(); 
		reader.close();
		return cnt;
	}

	
	/*public static void main(String[] args)
	{
		String fileName;
		int nBins;
		if(args.length==0)
		{
			fileName = (String)JOptionPane.showInputDialog(null,"Enter filename");
			if(fileName==null)
			{
				System.exit(0);	
			}
			nBins = 10;
		}
		else
		{
			fileName = args[0];	
		}
		HistPlotter op = new HistPlotter(fileName,nBins);	
	}*/

}